/* sane - Scanner Access Now Easy.

   Copyright (C) 2000 Mustek.
   Maintained by Tom Wang <tom.wang@mustek.com.tw>

   Updates (C) 2001 by Henning Meier-Geinitz.

   This file is part of the SANE package.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.

   As a special exception, the authors of SANE give permission for
   additional uses of the libraries contained in this release of SANE.

   The exception is that, if you link a SANE library with other files
   to produce an executable, this does not by itself cause the
   resulting executable to be covered by the GNU General Public
   License.  Your use of that executable is in no way restricted on
   account of linking the SANE library code into it.

   This exception does not, however, invalidate any other reasons why
   the executable file might be covered by the GNU General Public
   License.

   If you submit changes to SANE to the maintainers to be included in
   a subsequent release, you agree by submitting the changes that
   those changes may be distributed with this exception intact.

   If you write modifications of your own for SANE, it is your choice
   whether to permit this exception to apply to your modifications.
   If you do not wish that, delete this exception notice.

   This file implements a SANE backend for Mustek 1200UB flatbed scanners.  */
  
#ifndef mustek_usb_mid_h
#define mustek_usb_mid_h

#include "mustek_usb_low.h"
#include "../include/sane/sane.h"

/* adasensorcanon600 ------------------------------------------------------*/

/* for Canon 600 CIS */

static SANE_Bool usb_mid_c600_PrepareRgbX (ma1017 * chip, SANE_Word Dpi);
static SANE_Bool usb_mid_c600_PrepareMonoX (ma1017 * chip, SANE_Word Dpi);
static SANE_Bool usb_mid_c600_is600Mode (ma1017 * chip, SANE_Word Dpi);
static SANE_Bool usb_mid_c600_PrepareRgbX600Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c600_PrepareRgbX400Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c600_PrepareRgbX300Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c600_PrepareRgbX200Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c600_PrepareRgbX150Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c600_PrepareRgbX100Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c600_PrepareRgbX50Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c600_PrepareMonoX600Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c600_PrepareMonoX400Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c600_PrepareMonoX300Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c600_PrepareMonoX200Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c600_PrepareMonoX150Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c600_PrepareMonoX100Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c600_PrepareMonoX50Dpi (ma1017 * chip);


/* adasensor300600 ----------------------------------------------*/

/* for Canon 300/600 CIS */

static SANE_Bool usb_mid_c300600_PrepareRgbX (ma1017 * chip, SANE_Word Dpi);
static SANE_Bool usb_mid_c300600_PrepareMonoX (ma1017 * chip, SANE_Word Dpi);
static SANE_Bool usb_mid_c300600_is600Mode (ma1017 * chip, SANE_Word Dpi);
static SANE_Bool usb_mid_c300600_PrepareRgbX600Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c300600_PrepareRgbX400Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c300600_PrepareRgbX300Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c300600_PrepareRgbX200Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c300600_PrepareRgbX150Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c300600_PrepareRgbX100Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c300600_PrepareRgbX50Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c300600_PrepareMonoX600Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c300600_PrepareMonoX400Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c300600_PrepareMonoX300Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c300600_PrepareMonoX200Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c300600_PrepareMonoX150Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c300600_PrepareMonoX100Dpi (ma1017 * chip);
static SANE_Bool usb_mid_c300600_PrepareMonoX50Dpi (ma1017 * chip);

/* adamotor -------------------------------------------------------------*/

/* static functions... */
static SANE_Word usb_mid_motor1200_RgbCapability (SANE_Word Dpi);
static SANE_Word usb_mid_motor1200_MonoCapability (SANE_Word Dpi);

/* public & private functions */
static SANE_Bool usb_mid_motor1200_PrepareRgbY (ma1017 * chip, SANE_Word Dpi);
static SANE_Bool usb_mid_motor1200_PrepareMonoY (ma1017 * chip, SANE_Word Dpi);
static SANE_Bool usb_mid_motor1200_PrepareCalibrateRgbY (ma1017 * chip,
							 SANE_Word Dpi);
static SANE_Bool usb_mid_motor1200_PrepareCalibrateMonoY (ma1017 * chip,
							  SANE_Word Dpi);
static SANE_Bool usb_mid_motor1200_PrepareStep (ma1017 * chip,
						SANE_Word StepCount);
static SANE_Bool usb_mid_motor1200_PrepareHome (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareAdjust (ma1017 * chip,
						  CHANNEL chSelect);
#if 0
static SANE_Bool usb_mid_motor1200_SetDummyLine (ma1017 * chip);
#endif
static SANE_Bool usb_mid_motor1200_PrepareRgbY1200Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareRgbY400Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareRgbY240Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareRgbY600Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareRgbY200Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareRgbY120Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareRgbY300Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareRgbY150Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareRgbY100Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareRgbY75Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareRgbY60Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareRgbY50Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareMonoY1200Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareMonoY400Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareMonoY240Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareMonoY600Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareMonoY200Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareMonoY120Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareMonoY300Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareMonoY150Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareMonoY100Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareMonoY75Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareMonoY60Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareMonoY50Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareRgbYHalf300Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareRgbYBiFull300Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareRgbYBiFullx2300Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareMonoYHalf300Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareMonoYBiFull300Dpi (ma1017 * chip);
static SANE_Bool usb_mid_motor1200_PrepareMonoYBiFullx2300Dpi (ma1017 * chip);

/* adafrontend -------------------------------------------------------------*/

#define PGATableSize 64

static void usb_mid_front_SetFrontEndMode (ma1017 * chip, SANE_Byte Mode);
static void usb_mid_front_Enable (ma1017 * chip, SANE_Bool isEnable);
static void usb_mid_front_SetTopReference (ma1017 * chip, SANE_Byte Top);
static void usb_mid_front_SetRedOffset (ma1017 * chip, SANE_Byte Offset);
static void usb_mid_front_SetGreenOffset (ma1017 * chip, SANE_Byte Offset);
static void usb_mid_front_SetBlueOffset (ma1017 * chip, SANE_Byte Offset);
static void usb_mid_front_SetRedPGA (ma1017 * chip, SANE_Byte PGA);
static void usb_mid_front_SetGreenPGA (ma1017 * chip, SANE_Byte PGA);
static void usb_mid_front_SetBluePGA (ma1017 * chip, SANE_Byte PGA);
static void usb_mid_front_SetRGBSignal (ma1017 * chip);
#if 0
static int usb_mid_front_MaxPGAIndex (void);
#endif
#endif /* mustek_usb_mid_h */
